;***************************************************************************************
;
;	filename RTC.asm
;	MPLAB Ver8.10ɂăAZuEeXgς
;	checksum:0xc25f
;	@\SEIKO EPSON RTC-8564ƌ݊ƂȂ悤ӂĂ܂Bv@\
;	͍ւČ݊m߂Ă܂A^C}/A[@\AtÖ
;	Ȃǂ̃vORTC-8564̃AvP[VE}jAɉč\z
;	̂́A̍ו͌IɓɂȂĂȂ\܂B
;
;***************************************************************************************
	list      p=16f819 
	#include <p16F819.inc>

	errorlevel  -302

	__CONFIG   _CP_OFF & _WRT_ENABLE_1536 & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_ON & _MCLR_ON & _WDT_OFF & _PWRTE_ON & _INTRC_IO 

DEVICE_ADD		EQU	0xa2	; h2bɂfoCXR[h@RTC-8564Ɠ

; RTC-8564Œ`Ă郌WX^̃tO

RTC_STOP		EQU	5
RTC_TITP		EQU	4
RTC_AF		EQU	3
RTC_TF		EQU	2
RTC_AIE		EQU	1
RTC_TIE		EQU	0
RTC_VL		EQU	7
RTC_AE		EQU	7
RTC_FE		EQU	7
RTC_TE		EQU	7
RTC_TD0		EQU	0
;
; PORTÅerbg̊U
;
TRIMC0		EQU	0	; AN0, output/input NX^̕חeʒ[q
TRIMC1		EQU	1	; AN1, 
TRIMC2		EQU	2	; AN2, 
TRIMC3		EQU	3	; AN3, 
;PA4		EQU	4	; AN4, 
;MCLR		EQU	5	; input, Zbg
CLKOUT		EQU	6	; output, NbNi1gzjo
INTOUT		EQU	7	; output/input, ^C}[܂̓A[荞ݏo
;
; PORTB̊erbg̊U
;
;INT		EQU	0	; sgpiój
;SDA		EQU	1	; h2bf[^M
;SDO		EQU	2	; sgpiój
CLKOE		EQU	3	; input, NbNo̓Cl[uMivAbvj
;SCL		EQU	4	; h2bNbN
;SS		EQU	5	; sgpiój	
;T10OSO		EQU	6	; óivpNX^j
;T10OSI		EQU	7	; ́ivpNX^j

;**************************************************
;
;	ϐ錾
;
;**************************************************
;
; RTC8564 ݊WX^
;
RTCRegister		EQU	0x20
Control1		EQU	RTCRegister + 0x00
Control2		EQU	RTCRegister + 0x01
Seconds		EQU	RTCRegister + 0x02
Minutes		EQU	RTCRegister + 0x03
Hours		EQU	RTCRegister + 0x04
Days		EQU	RTCRegister + 0x05
Weekdays		EQU	RTCRegister + 0x06
Months		EQU	RTCRegister + 0x07
Years		EQU	RTCRegister + 0x08
MinuteAlarm		EQU	RTCRegister + 0x09
HourAlarm		EQU	RTCRegister + 0x0a
DayAlarm		EQU	RTCRegister + 0x0b
WeekdayAlarm		EQU	RTCRegister + 0x0c
ClockFreq		EQU	RTCRegister + 0x0d
RtcTimerControl	EQU	RTCRegister + 0x0e
RtcTimer		EQU	RTCRegister + 0x0f
;
; ě̓t̕\
;
MaxDayTable	EQU	0x30		; 12bytes
;
; ܂ł͂ddoqnlNɓeRs[

; ȉ͊eoNʃANZẌ
;
StatusBuffer		EQU	0x70	; h2b̃Xe[^XWX^̃obt@
GetPTR		EQU	0x71	; f[^̃|C^
MaxMonthDay		EQU	0x72	; ̓t
_a		EQU	0x73	; ꎞIɎgpϐ
_b		EQU	0x74
_c		EQU	0x75
_n		EQU	0x76
w_count		EQU	0x77

stop_flag		EQU	0x78	; h2b̃XgbvRfBVo
tmint_flag		EQU	0x79	; ^C}̈v
timer_buffer		EQU	0x7a	; JE^l̍ă[hp
alarm_flag		EQU	0x7b	; A[̈v

; 荞݊֌WAp̃Rg̓ev[g

w_temp		EQU	0x7E        ; variable used for context saving 
status_temp		EQU	0x7F        ; variable used for context saving

;***********************************************
;
; vOER[h
;
;
;***********************************************

; vOEX^[g

	ORG     0x000             ; processor reset vector
	goto    main              ; go to beginning of program
	
; 荞݃xN^

	ORG     0x004             ; interrupt vector location
	movwf   w_temp            ; save off current W register contents
	movf	STATUS,w          ; move status register into W register
	movwf	status_temp       ; save off contents of STATUS register

	banksel PIR1
	btfss	PIR1,SSPIF		; SSP 荞݂H	
	goto	isr10
	bcf	PIR1,SSPIF
	call	SSPproc		; 荞ݏ

isr10
	btfss	PIR1,TMR1IF		; ^C}荞݂H
	goto	isr_exit
	bcf	PIR1,TMR1IF		; tONA
	call	RTCproc		; 荞ݏ

isr_exit
	movf    status_temp,w     ; retrieve copy of STATUS register
	movwf	STATUS            ; restore pre-isr STATUS register contents
	swapf   w_temp,f
	swapf   w_temp,w          ; restore pre-isr W register contents
	retfie                    ; return from interrupt

; CEvO@ݒ

main
	banksel	OSCCON
	movlw	b'01100000'		; 4MHzœ
	movwf	OSCCON
check_clock
	btfss	OSCCON,IOFS		; NbN̈҂
	goto	check_clock

	banksel	EECON1
	clrf	EECON1
	
	banksel	RTCRegister		; WX^̏lddoqnl烍[h
	movlw	RTCRegister
	movwf	FSR
	movlw	0x60		; 20h7FhԒn̓eNA
fregclr
	clrf	INDF
	incf	FSR,f
	addlw	0xff		;w--	
	btfss	STATUS,Z
	goto	fregclr

	clrf	_a		; src address
	movlw	RTCRegister
	movwf	_b		; dest address
	movlw	.28		; 16 regsters + 12 monthes
	movwf	_c		; byte count
	call	readEE		; EEPROM̓e[h

	bsf	ClockFreq,RTC_FE
	call	GetMaxDay		; ̓tZbg
	movwf	MaxMonthDay

	banksel	TRISA		; bank 1
	movlw	0xa0		; RA7(INTOUT) & RA5(MCLR) input
	movwf	TRISA
	movlw	b'00011010'		; RB4(SCL), RB3(CLKOE) & RB1(SDA) input
	movwf	TRISB
	bcf	OPTION_REG,NOT_RBPU

	banksel	RTCRegister		; bank 0
	call	XcapTrim	
	clrf	PORTB

	movlw	b'00111110'		; h2bC^[tFX̐ݒ
	movwf	SSPCON		; 7-bit@address, slave mode
	banksel	SSPADD		; bank 1
	movlw	DEVICE_ADD
	movwf	SSPADD
	clrf	SSPSTAT
	bsf	PIE1,SSPIE		; h2b荞݂Cl[u
	bsf	PIE1,TMR1IE		; ^C}1荞݂Cl[u

	banksel	TMR1H		; bank 0
	movlw	0xc0		; 0.5b
	movwf	TMR1H
	clrf	TMR1L
	movlw	b'00001111'
	movwf	T1CON
	bsf	INTCON,PEIE		; ӑfq̊荞݂Cl[u
	bsf	INTCON,GIE		; 荞ݑSʂCl[u

; CEvO@iv[v

IdleLoop
	sleep			; X[vA荞݂ɂĕA

	btfss	STATUS,NOT_PD	; NOT_PDrbgVLɔf
	bsf	Seconds,RTC_VL

change_outputs
	btfss	Control2,RTC_AIE	; A[EtȌԂo͂ɔf
	goto	check_timer_out
	btfsc	Control2,RTC_AF
	goto	enableINTOUT

check_timer_out
	btfss	Control2,RTC_TIE	; ^C}EtȌԂo͂ɔf
	goto	disableINTOUT
	btfss	Control2,RTC_TF
	goto	disableINTOUT

enableINTOUT
	banksel	TRISA		; INTOUTRTC-8564ł̓I[vEhCo
	bcf	TRISA,INTOUT		; ƂȂĂBohbŗގ̓邽
	banksel	Control1		; [q̓[hɂ邱ƂŃItAo̓[h
	bcf	PORTA,INTOUT		; ɂ邱ƂŃIƂȂ悤ɂĂB
	goto	checkI2Cstop

disableINTOUT
	banksel	TRISA
	bsf	TRISA,INTOUT		; ̓[hio̓gWX^Itj
	banksel	Control1

checkI2Cstop
	btfss	stop_flag,0		; h2b̃XgbvERfBV`FbN
	goto	IdleLoop

	clrf	stop_flag		; stop condition detected
	btfss	Control1,RTC_STOP	; RTC stop?
	goto	count_begin

	banksel	PIE1		; ^C}1`FbN
	btfss	PIE1,TMR1IE		; łɒ~H
	goto	stop_continue

	bcf	PIE1,TMR1IE		; ^C}1~
	banksel	RTCRegister
	movlw	0x80		; bWX^NA
	andwf	Seconds,f
	bcf	PORTA,CLKOUT
	movlw	RTCRegister		; src@address
	movwf	_a
	clrf	_b		; dest address = 0
	movlw	0x10
	movwf	_c		; byte count
	call	writeEE		; WX^̓eEEPROM
	call	XcapTrim

stop_continue
	banksel	RTCRegister
	goto	IdleLoop

count_begin
	banksel	PIE1		; v̍ĊJ
	btfsc	PIE1,TMR1IE		; łɓH
	goto	count_continue

	movlw	RTCRegister		; src address
	movwf	_a
	clrf	_b		; dest address = 0
	movlw	0x10
	movwf	_c		; byte count
	call	writeEE		; WX^̓eEEPROM
	banksel	PIE1
	bsf	PIE1,TMR1IE		; ^C}荞݂̍ĊJ

count_continue
	banksel	Control1
	goto	IdleLoop		; iv[vp


;h2bC^[tF[X̃hCo
	
SSPproc
	banksel	SSPSTAT
	movf	SSPSTAT,w		; Xe[^X[h
	andlw	b'00111101'		; svȃrbg}XN
	banksel	SSPBUF
	movwf	StatusBuffer		; rpɕۑ

	movlw	b'00001001'		; Write start
	xorwf	StatusBuffer,w
	btfss	STATUS,Z
	goto	DataWrite
	
	clrf	GetPTR
	movf	SSPBUF,w		; dummy read
	return
	
DataWrite				; p Write
	movlw	b'00101001'		; buffer is full.
	xorwf	StatusBuffer,w
	btfss	STATUS,Z
	goto	ReadStart

	movf	GetPTR,w
	btfss	STATUS,Z
	goto	ss02

	incf	GetPTR,f		; register address set
	movf	SSPBUF,w
	addlw	RTCRegister		; buffer top
	movwf	FSR
	goto	xx02

ss02
	movf	SSPBUF,w
	movwf	INDF
	movf	FSR,w
	sublw	RtcTimer		; ^C}lH
	btfss	STATUS,Z
	goto	ss03

	movf	RtcTimer,w		; s[gpɕۑ
	movwf	timer_buffer	
ss03
	incf	FSR,f
xx02
	return
	
ReadStart
	movlw	b'00001100'		; Read startH
	xorwf	StatusBuffer,w
	btfsc	STATUS,Z
	goto	WriteI2C

	movlw	b'00101100'		; XgbvERfBV`FbN
	xorwf	StatusBuffer,w
	btfss	STATUS,Z
	goto	StopDetected

WriteI2C	
	movf	INDF,W		; p Read
	banksel	SSPSTAT
empty_check
	btfsc	SSPSTAT,BF		; obt@󂭂̂mF
	goto	empty_check
	banksel	SSPCON
data_write
	bcf	SSPCON,WCOL		; Clear the WCOL flag.
	movwf	SSPBUF		; Write the byte in WREG
	btfsc	SSPCON,WCOL		; Was there a write collision?
	goto	data_write
	bsf	SSPCON,CKP		; Release the clock.
	incf	FSR,f		; Increment the buffer index.
	return

StopDetected
	btfsc	StatusBuffer,4	; XgbvERfBVH
	bsf	stop_flag,0		; tOZbg
	return

; v

RTCproc
	movlw	0xc0		; 荞݂1bԂ2
	movwf	TMR1H
	incf	tmint_flag,f		; O0.5bƌ㔼0.5bɏ𕪂
	btfss	tmint_flag,0
	goto	time_calc

	btfss	PORTB,CLKOE		; NbNo͂i[qjH
	goto	timer_check
	btfss	ClockFreq,RTC_FE	; NbNo͂itOjH
	goto	timer_check
	bsf	PORTA,CLKOUT		; NbNóigj
	goto	timer_check

time_calc
	bcf	PORTA,CLKOUT		; NbNóikj
	movlw	Seconds		; b̃JEgAbv
	movwf	FSR
	movf	INDF,w
	movwf	_a
	bcf	_a,RTC_VL
	movlw	0x59
	subwf	_a,w
	btfss	STATUS,Z
	goto	IncBCD

	movlw	0x80		; ̃JEgAbv
	andwf	Seconds,f
	movlw	Minutes
	movwf	FSR
	movlw	0x59
	subwf	INDF,w
	btfss	STATUS,Z
	goto	IncBCD

	clrf	Minutes		; ̃JEgAbv
	movlw	Hours
	movwf	FSR
	movlw	0x23
	subwf	INDF,w
	btfss	STATUS,Z
	goto	IncBCD

	clrf	Hours		; 
	movlw	6
	subwf	Weekdays,w
	btfsc	STATUS,Z
	goto	new_week
	incf	Weekdays,f
	goto	day_check
new_week
	clrf	Weekdays		; ̏T
day_check
	movlw	Days
	movwf	FSR
	movf	MaxMonthDay,w
	subwf	INDF,w
	btfss	STATUS,Z
	goto	IncBCD

	movlw	1		; 
	movwf	Days
	movlw	Months
	movwf	FSR
	movlw	0x12
	subwf	INDF,w
	btfss	STATUS,Z
	goto	next_month

	movlw	1		; VNI
	movwf	Months
	movlw	0x31
	movwf	MaxMonthDay
	movlw	Years
	movwf	FSR
	goto	IncBCD

next_month
	call	IncBCD		; ̏
	call	GetMaxDay
	movwf	MaxMonthDay

	movlw	2		; Febrary
	subwf	Months,w
	btfss	STATUS,Z
	return

	movlw	3		; 邤Ñ`FbN
	andwf	Years,w
	btfsc	STATUS,Z
	incf	MaxMonthDay,f	; 29th on Feb.
	return

IncBCD
	incf	INDF,f		; abcɂJEgAbv
	movf	INDF,w
	andlw	0x0f
	sublw	0x0a
	btfss	STATUS,Z
	return
	movlw	6		; 10̌̓rbg4
	addwf	INDF,f
	return


timer_check
	btfss	RtcTimerControl,RTC_TE	; ^C}@\ZbgĂ邩
	goto	alarm_check
	btfss	RtcTimerControl,RTC_TD0
	goto	just_job		; every 1 sec

	movf	Seconds,w		; every 1 min
	andlw	0x80
	btfss	STATUS,Z
	goto	alarm_check

just_job
	movf	RtcTimer,w		; ^C}l0Ȃ΃A[̃`FbN
	btfsc	STATUS,Z
	goto	alarm_check

	decfsz	RtcTimer,f		; 0łȂ΃JEg_E
	goto	alarm_check

	btfss	Control2,RTC_TITP	; H
	goto	timeup
	movf	timer_buffer,w	; ă[h
	movwf	RtcTimer
timeup	
	bsf	Control2,RTC_TF	; tOZbg

alarm_check
	btfss	Control2,RTC_AIE	; A[@\ZbgĂ邩H
	goto	not_matched

	movf	Minutes,w		; 
	subwf	MinuteAlarm,w
	btfsc	STATUS,Z
	goto	check_m

	btfss	MinuteAlarm,RTC_AE
	goto	not_matched
check_m
	movf	Hours,w		; 
	subwf	HourAlarm,w
	btfsc	STATUS,Z
	goto	check_d

	btfss	HourAlarm,RTC_AE
	goto	not_matched
check_d
	movf	Days,w		; 
	subwf	DayAlarm,w
	btfsc	STATUS,Z
	goto	check_w

	btfss	DayAlarm,RTC_AE
	goto	not_matched
check_w
	movf	Weekdays,w		; j
	subwf	WeekdayAlarm,w
	btfsc	STATUS,Z
	goto	matched

	btfss	WeekdayAlarm,RTC_AE
	goto	not_matched

matched
	movf	MinuteAlarm,w	; AErbg̃`FbN
	andwf	HourAlarm,w
	andwf	DayAlarm,w
	andwf	WeekdayAlarm,w
	andlw	0x80		; ׂăZbgĂΉȂ
	btfss	STATUS,Z
	goto	not_matched

	movf	alarm_flag,w		; łɈvς݁H
	btfss	STATUS,Z
	goto	check_end

	bsf	alarm_flag,0		; A[o
	bsf	Control2,RTC_AF
	goto	check_end

not_matched
	clrf	alarm_flag
	bcf	Control2,RTC_AF
check_end
	return

; ̓t𓾂

GetMaxDay
	movf	Months,w
	movwf	_a		; abcoCiɕϊ
	btfss	_a,4
	goto	gm10
	movlw	7
	goto	gm20
gm10
	movlw	1		; e[u̐擪킹
gm20
	subwf	_a,f

	movlw	MaxDayTable
	addwf	_a,w
	movwf	FSR
	movf	INDF,w
	return

; חeʂ̐ݒ --- Control1 WX^STOPrbgɂv삪~ꂽƂɐݒ肳

XcapTrim
	movf	Control1,w		; @\gꂽ2rbg`FbN
	andlw	3
	movwf	_a
	btfsc	STATUS,Z
	goto	trim_out		; 00Ȃ΍őe

	sublw	1
	btfss	STATUS,Z
	goto	trim10
	movlw	b'00000101'		; bit0, bit2ɂeʒǉ
	goto	trim_out
trim10
	movf	_a,w
	sublw	2
	btfss	STATUS,Z
	goto	trim11
	movlw	b'00001010'		; bit1, bit3ɂeʒǉ
	goto	trim_out
trim11
	movlw	b'00001111'		; 11Ȃ΍ŏe
trim_out
	banksel	TRISA
	movwf	_a
	movf	TRISA,w
	andlw	0xf0
	iorwf	_a,w
	movwf	TRISA		; o̓[hɂȂ[qɐڑĂeʂǉ
	banksel	Control1
	return

; EEPROM̓ǂݍ
; char	getEE(char w)
; return data into w

getEE
	banksel	EEADR
	movwf	EEADR
	banksel	EECON1
	bsf	EECON1,RD
	banksel	EEDATA
	movf	EEDATA,w
	return

; EEPROMւ̏
; void	putEE
; use _n

putEE
	banksel	EECON1
	bcf	INTCON,GIE
	movlw	h'55'
	movwf	EECON2
	movlw	h'aa'
	movwf	EECON2
	bsf	EECON1,WR
	bsf	INTCON,GIE

	movlw	.7		;wait 7msec
	movwf	_n
ee_wait
	movlw	.250
	movwf	w_count
	call	wait_loop
	decfsz	_n,f
	goto	ee_wait
	return

; EEPROMobt@ւ̓ǂݍ
; void	readEE(char *_a, char *_b, unsigned char _c)
; read EEPROM from _a, store to _b, _c bytes

readEE
	banksel	EECON1
	bcf	EECON1,EEPGD
	bcf	EECON1,FREE
	movf	_b,w
	movwf	FSR
rd10
	movf	_a,w
	call	getEE
	movwf	INDF
	incf	_a,f
	incf	FSR,f
	decfsz	_c,f
	goto	rd10
	banksel	RTCRegister
	return

; obt@EEPROM֏
; char	writeEE(char *_a, char *_b, unsigned char _c)
; read from _a, write EEPROM to _b, _c bytes */
; return 1 if OK else 0 */
;
writeEE
	banksel	EECON1
	bsf	EECON1,WREN
	movf	_a,w
	movwf	FSR
wr10
	banksel	EEADR
	movf	_b,w		;dest
	movwf	EEADR
	movf	INDF,w
	movwf	EEDATA
	call	putEE

	banksel	EEDATA
	movf	EEDATA,w
	banksel	EECON1
	bsf	EECON1,RD		;verify
	banksel	EEDATA
	xorwf	EEDATA,w
	btfss	STATUS,Z
	goto	write_err

	incf	FSR,f
	incf	_b,f
	decfsz	_c,f
	goto	wr10

	banksel	EECON1
	bcf	EECON1,WREN
	movlw	.1
	goto	wrex
write_err
	clrw
wrex
	banksel	RTCRegister
	return
;
; about 4*w_count usec delay
;
wait_loop
	clrwdt			;1 Tcy
	decfsz	w_count,f		;1(2) Tcy
	goto	wait_loop		;2 Tcy
	return			;2 Tcy

;*********************************************************************
;
; ddoqnl̏f[^@ł2008N1231235945b
;
;*********************************************************************

	ORG	0x2100

	DE	0x00		; Control1
	DE	0x00		; Control2
	DE	0x45		; Seconds
	DE	0x59		; Minutes

	DE	0x23		; Hours
	DE	0x31		; Days
	DE	0x00		; Weekdays
	DE	0x12		; Months

	DE	0x08		; Years
	DE	0x00		; Minute Alarm
	DE	0x80		; Hour Alarm
	DE	0x80		; Day Alarm

	DE	0x80		; Weekday Alarm
	DE	0x83		; CLKOUT Frq.
	DE	0x02		; Timer control
	DE	0x00		; Timer	

	DE	0x31,0x28,0x31	; Jan, Feb, March
	DE	0x30,0x31,0x30	; April, May, June
	DE	0x31,0x31,0x30	; July, August,September
	DE	0x31,0x30,0x31	; October,Nevember,December	

	END
